 program FontMaker2;
  uses crt,graph13h,curs13h,mouse;
  type
   zagtype=record
    name:string[9];
    fsize:word;
    xchar,ychar:byte;
    t:byte;
    chsize:byte;
   end;
   fontar=array[0..10] of byte;
   fonttype=record
    zag:zagtype;
    prop:array[0..223] of byte;
    im:^fontar;
   end;
  var
   ch:char;
   size:word;
   st,st1:string[40];
   i,j,dx,dy:integer;
   x,y,sx,sy:integer;
   p:pointer;
   b,bs:byte;
   font:fonttype;
  procedure myrect(x1,y1,x2,y2:word;fl:boolean);
   begin
    if fl then
    color:=30 else color:=24;
    vline(x1,y1,y2-1);
    hline(x1,x2-1,y1);
    if fl then color:=24 else color:=30;
    vline(x2,y1+1,y2);
    hline(x1+1,x2,y2);
    color:=26;
    putpixel13(x1,y2);
    putpixel13(x2,y1);
   end;
  procedure create;
   begin
    textcolor(15);
    gotoxy(1,18);
    with font.zag do begin
    write('                      (6-10,12,14,16,20,24) : ');
    textcolor(14);
    readln(ychar);
    textcolor(15);
    writeln;
    write(' ᨬ  ᨬ            (4,8,12,16) : ');
    textcolor(14);
    readln(xchar);
    t:=3;
    chsize:=xchar*ychar shr 2;
    size:=chsize*224;
    end;
    size:=size;
    fillchar(font.prop,224,3);
    getmem(font.im,size);
    fillchar(font.im^,size,0);
   end;
  procedure save;
   var
    f:file;
    s:word;
   begin
    if font.zag.t=10 then exit;
    gotoxy(1,18); textcolor(14);
    write('   (9c) : '); readln(font.zag.name);
    write('  䠩 (8c) : '); readln(st);
    if pos('.',st)=0 then st:=st+'.fnt';
    assign(f,st);
    {$I-}
    reset(f,1);
    if ioresult=0 then begin
     write(' 䠩 ! ९ (Y/N) ?');
     ch:=readkey;
     if not (ch in ['Y','y']) then exit;
     close(f);
    end;
    rewrite(f,1);
    with font.zag do begin
     t:=3; fsize:=size+240;
    end;
    blockwrite(f,font.zag,16);
    blockwrite(f,font.prop,224);
    blockwrite(f,font.im^,size);
   end;
  procedure load;
   var
    f:file;
   begin
    gotoxy(1,18); textcolor(14);
    write('  䠩 : '); readln(st);
    if pos('.',st)=0 then st:=st+'.fnt';
    assign(f,st);
    reset(f,1);
    if ioresult<>0 then exit;
    if font.zag.t<>10 then freemem(font.im,size);
    blockread(f,font.zag,16);
    size:=font.zag.chsize*224;
    getmem(font.im,size);
    blockread(f,font.prop,224);
    blockread(f,font.im^,size);
   end;
  procedure info;
   begin
    gotoxy(1,17); textcolor(11);
    writeln('  : ',font.zag.name:9);
    writeln('ଠ    : ',font.zag.xchar,'x',font.zag.ychar,' 祪.');
    writeln('    : ',size:5,' .');
    readkey;
   end;
  procedure cursor; external; {$L curs11.obj}
  procedure edit;
    const
     ar:array[0..3,0..3] of byte=((29,1,25,3),(12,14,4,42),(22,30,16,26),(10,16,2,2));
   var
    step:byte;
    p:pointer;
    xc,yc:byte;
    xs,ys:word;
    c:byte;
    mycolor:byte;
    col:array[0..3] of byte;
    xm,ym:word;
    char:array[0..15,0..24] of byte;
    curchar:byte;
   procedure loadchar(n:byte);
    var
     o:word;
     b,c:byte;
    begin
     o:=n*font.zag.chsize;
     for i:=0 to yc-1 do
      for j:=0 to (xc shr 2)-1 do begin
       b:=font.im^[o];
       for c:=0 to 3 do begin
        char[j*4+c,i]:=b and 3;
        b:=b shr 2;
       end;
       o:=o+1;
      end;
    end;
    procedure savechar(n:byte);
     var
      o:word;
      b,c:byte;
      l:byte;
     begin
      l:=3;
      for i:=0 to yc-1 do
       for j:=l to xc-1 do
        if char[j,i]>0 then l:=j+1;
      font.prop[n]:=l;
      o:=n*font.zag.chsize;
      for i:=0 to yc-1 do
       for j:=0 to (xc shr 2)-1 do begin
        b:=0;
        for c:=3 downto 0 do begin
         b:=b+char[j*4+c,i];
         if c>0 then
          b:=b shl 2;
        end;
        font.im^[o]:=b;
        o:=o+1;
       end;
     end;
   procedure showchar;
    var
     b,c:byte;
    begin
     for i:=0 to 3 do begin
      color:=ar[i,0];
      bar13(166+i*21,156,185+i*21,189);
     end;
     for i:=0 to xc-1 do
      for j:=0 to yc-1 do begin
       color:=col[char[i,j]];
       bar13(10+i*step,10+j*step,8+i*step+step,8+j*step+step);
       b:=char[i,j];
       if b>0 then
        for c:=0 to 3 do begin
         color:=ar[c,b];
         putpixel13(168+c*21+i,158+j);
        end;
      end;
    end;
   begin
    if font.zag.t=10 then exit;
    setmode($13);
    fon:=28;
    clear13;
    with font.zag do begin
     xc:=xchar;
     yc:=ychar;
    end;
    step:=14;
    if yc>8 then step:=10;
    if yc>13 then step:=8;
    if yc>16 then step:=6;
    if yc>18 then step:=5;
    if (xc>=12) and (step>8) then step:=10;
    if (xc=16) and (step>6) then step:=8;
    y:=8+yc*step; x:=8+xc*step;
    xm:=x; ym:=y;
    myrect(5,5,13+step*xc,13+yc*step,on);
    myrect(6,6,12+step*xc,12+yc*step,on);
    myrect(9,9,9+step*xc,9+yc*step,off);
    color:=29;
    bar13(10,10,x,y);
    color:=18;
    for i:=1 to xc-1 do
     vline(9+step*i,10,y);
    for i:=1 to yc-1 do
     hline(10,x,9+step*i);
    color:=10;
    y:=round(yc*0.83);
    hline(10,x,9+y*step);
    if yc>7 then begin
     y:=round(yc*0.3);
     hline(10,x,9+y*step);
    end;
    if yc>10 then begin
     y:=round(yc*0.085);
     hline(10,x,9+y*step);
    end;
    col[0]:=29; col[1]:=1; col[2]:=26; col[3]:=3;
{    for j:=1 to yc do
     for i:=1 to xc do begin
      color:=}

    curchar:=33;
    loadchar(curchar);
    myrect(163,3,299,124,on);
    myrect(164,4,298,123,on);
    myrect(167,7,296,120,off);
    setfont(font8); color:=17;
    directvideo:=false;
    textcolor(9);
    for i:=2 to 15 do
     for j:=0 to 15 do begin
      gotoxy(22+j,i);
      write(chr(i*16+j));
     end;
    showchar;
    mycolor:=1;
    myrect(5,150,130,195,on);
    myrect(4,149,131,196,on);
    myrect(8,155,30,190,off);
    color:=col[mycolor];
    bar13(9,156,29,189);
    for i:=0 to 3 do begin
     myrect(40+i*20,155,59+i*20,190,on);
     color:=col[i];
     bar13(41+i*20,156,58+i*20,189);
    end;
    myrect(159,149,311,196,on);
    myrect(158,148,312,197,on);
    myrect(260,155,308,170,on);
    myrect(260,175,308,190,on);
    color:=16; wrtstr('',265,159);
    wrtstr('',275,179);
    myrect(165,155,250,190,off);
    color:=22; for i:=1 to 3 do vline(165+i*21,156,189);
    p:=@cursor;
    usecurs:=on;
    setcursor(p,0,0);
    msgetpos(x,y);
    x:=x shr 1;
    movecurs(x,y);
    msgetbut(b); bs:=b;
    setfont(font8); color:=17;
    wrtstr(' :',240,130);
    wrtstr(chr(curchar+32),290,130);
    repeat
     xs:=x; ys:=y; bs:=b;
     delay(30);
     msgetpos(x,y);
     x:=x shr 1;
     if (x<>xs) or (y<>ys) then
      movecurs(x,y);
     msgetbut(b);
     if (b and 1)>0 then
      if (x>=10) and (y>=10) and (x<=xm) and (y<=ym) then begin
       color:=col[mycolor]; i:=(x-10) div step; j:=(y-10) div step;
       hidecurs;
       bar13(10+i*step,10+j*step,8+i*step+step,8+j*step+step);
       showcurs;
       char[i,j]:=mycolor;
       for c:=0 to 3 do begin
        color:=ar[c,mycolor];
        putpixel13(168+c*21+i,158+j);
       end;
      end;
      if (b and 2)>0 then
       if (x>=10) and (y>=10) and (x<=xm) and (y<=ym) then begin
        color:=col[0]; i:=(x-10) div step; j:=(y-10) div step;
       hidecurs;
       bar13(10+i*step,10+j*step,8+i*step+step,8+j*step+step);
       showcurs;
       char[i,j]:=0;
       for c:=0 to 3 do begin
        color:=ar[c,0];
        putpixel13(168+c*21+i,158+j);
       end;
      end;
     if (b<>bs) and ((b and 1)>0) then begin
      if (x>=40) and (x<=119) and (y>=155) and (x<=190) then begin
       hidecurs; i:=(x-40) div 20;
       myrect(40+i*20,155,59+i*20,190,off);
       showcurs;
       mycolor:=i;
       color:=col[mycolor];
       bar13(9,156,29,189);
       for j:=1 to 6+i*2 do begin
        sound(200+j*300); delay(2); nosound;
       end;
       delay(50);
       hidecurs;
       myrect(40+i*20,155,59+i*20,190,on);
       showcurs;
      end;
      if (x>=260) and (y>=175) and (x<=308) and (y<=190) then begin
       for i:=0 to yc-1 do
        for j:=1 to xc-1 do
         if (char[j,i]=0) and (char[j-1,i]=1) then
          char[j,i]:=2;
       hidecurs;
       showchar;
       showcurs;
      end;
      if (x>=260) and (y>=155) and (y<=170) and (x<=308) then begin
       fillchar(char,sizeof(char),0);
       hidecurs;
       showchar;
       showcurs;
      end;
     end;
     if (b and 1)>0 then
      if (x>=168) and (x<296) and (y>=8) and (y<120) then begin
       savechar(curchar);
       curchar:=((y-8) shr 3)*16+(x-168) shr 3;
       loadchar(curchar);
       for j:=5 downto 0 do begin
        sound(300+j*500); delay(2); nosound; end;
       hidecurs;
       showchar;
       showcurs;
       color:=28; bar13(290,130,300,140); color:=1;
       wrtstr(chr(curchar+32),290,130);
       delay(120);
      end;
     bs:=b;
     if keypressed then ch:=readkey;
    until ch=#27;
    hidecurs;
    savechar(curchar);
    usecurs:=off;
    setmode(1);
    ch:=#1;
   end;
  begin
   setmode(1);
   font.zag.t:=10;
   repeat
    clrscr;
    gotoxy(10,8);
    textcolor(10);
    writeln('      :');
    writeln; textcolor(14);
    writeln('            [1] - ᮧ  ');
    writeln('            [2] - ࠭  ');
    writeln('            [3] - 㧨  ');
    writeln('            [4] - ।஢  ');
    writeln('            [5] -   ');
    writeln('          [Esc] - 室');
    ch:=readkey;
    case ch of
     '1':create;
     '2':save;
     '3':load;
     '4':edit;
     '5':info;
    end;
   until ch=#27;
   setmode(3);
  end.
